package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineOrderTemplateLogs struct {
	api.Api
}

// GetPage 获取委托下单模板列表
// @Summary 获取委托下单模板列表
// @Description 获取委托下单模板列表
// @Tags 委托下单模板
// @Param name query string false "模板名称"
// @Param userId query int64 false "用户id"
// @Param type query int64 false "模板类型:1=单独添加;2=批量添加"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineOrderTemplateLogs}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-order-template-logs [get]
// @Security Bearer
func (e LineOrderTemplateLogs) GetPage(c *gin.Context) {
    req := dto.LineOrderTemplateLogsGetPageReq{}
    s := service.LineOrderTemplateLogs{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineOrderTemplateLogs, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取委托下单模板失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取委托下单模板
// @Summary 获取委托下单模板
// @Description 获取委托下单模板
// @Tags 委托下单模板
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineOrderTemplateLogs} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-order-template-logs/{id} [get]
// @Security Bearer
func (e LineOrderTemplateLogs) Get(c *gin.Context) {
	req := dto.LineOrderTemplateLogsGetReq{}
	s := service.LineOrderTemplateLogs{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineOrderTemplateLogs

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取委托下单模板失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建委托下单模板
// @Summary 创建委托下单模板
// @Description 创建委托下单模板
// @Tags 委托下单模板
// @Accept application/json
// @Product application/json
// @Param data body dto.LineOrderTemplateLogsInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-order-template-logs [post]
// @Security Bearer
func (e LineOrderTemplateLogs) Insert(c *gin.Context) {
    req := dto.LineOrderTemplateLogsInsertReq{}
    s := service.LineOrderTemplateLogs{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建委托下单模板失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改委托下单模板
// @Summary 修改委托下单模板
// @Description 修改委托下单模板
// @Tags 委托下单模板
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineOrderTemplateLogsUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-order-template-logs/{id} [put]
// @Security Bearer
func (e LineOrderTemplateLogs) Update(c *gin.Context) {
    req := dto.LineOrderTemplateLogsUpdateReq{}
    s := service.LineOrderTemplateLogs{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改委托下单模板失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除委托下单模板
// @Summary 删除委托下单模板
// @Description 删除委托下单模板
// @Tags 委托下单模板
// @Param data body dto.LineOrderTemplateLogsDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-order-template-logs [delete]
// @Security Bearer
func (e LineOrderTemplateLogs) Delete(c *gin.Context) {
    s := service.LineOrderTemplateLogs{}
    req := dto.LineOrderTemplateLogsDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除委托下单模板失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
